---
title: 'XRSession: visibilitychange event'
slug: Web/API/XRSession/visibilitychange_event
tags:
  - API
  - AR
  - Blurred
  - Mixed
  - Reality
  - Reference
  - VR
  - Virtual
  - Visibility
  - Visible
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRSession
  - active
  - augmented
  - events
  - focused
  - hidden
  - visibilitychange
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_Header}}</p>

<p><span class="seoSummary">The <code><strong>visibilitychange</strong></code> event is sent to an {{domxref("XRSession")}} to inform it when it becomes visible or hidden, or when it becomes visible but not currently focused.</span> Upon receiving the event, you can check the value of the session's {{domxref("XRSession.visibilityState", "visibilityState")}} property to determine the new visibility state.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("XRSessionEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("XRSession.onvisibilitychange", "onvisibilitychange")}}</td>
  </tr>
 </tbody>
</table>

<p>When the <code>XRSession</code> receives this event, the visibility state has already been changed.</p>

<h2 id="Examples">Examples</h2>

<p>This example demonstrates how to listen for a <code>visibilitychange</code> event on a WebXR session, using {{domxref("EventTarget.addEventListener", "addEventListener()")}} to begin listening for the event:</p>

<pre class="brush: js">navigator.xr.requestSession("inline").then((xrSession) =&gt; {
  xrSession.addEventListener("visibilitychange", e =&gt; {
    switch(e.session.visiblityState) {
      case "visible":
      case "visible-blurred":
        mySessionVisible(true);
        break;
      case "hidden":
        mySessionVisible(false);
        break;
    }
  });
});
</pre>

<p>When a visibility state change occurs, the event is received and dispatched to a function <code>mySessionVisible()</code>, with a Boolean parameter indicating whether or not the session is presently being displayed to the user.</p>

<p>You can also create the event handler by assigning it to the {{domxref("XRSession")}}'s {{domxref("XRSession.onvisibilitychange", "onvisibilitychange")}} event handler property, like this:</p>

<pre class="brush: js">xrSession.onvisibilitychange = (e) =&gt; {
  /* event handled here */
};</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#eventdef-xrsession-visibilitychange","visibilitychange event")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRSession.visibilitychange_event")}}</div>
